当前位置:   article > 正文

Java-数据结构-链表<二>_java detectcycle

java detectcycle

承接上文 Java-数据结构-链表<一>

一. 链表简单介绍 

见 Java-数据结构-链表<一>

二. 链表的代码实现

见 Java-数据结构-链表<一>

三. leetcode&牛客实例

1-6 见 Java-数据结构-链表<一>

7. leetcode160 相交链表

        给你两个单链表的头节点 headA 和 headB ,请你找出并返回两个单链表相交的起始节点。如果两个链表不存在相交节点,返回 null 。
图示两个链表在节点 c1 开始相交:

题目数据 保证 整个链式结构中不存在环。
注意,函数返回结果后,链表必须 保持其原始结构 。
自定义评测:
评测系统 的输入如下(你设计的程序 不适用 此输入):
intersectVal - 相交的起始节点的值。如果不存在相交节点,这一值为 0
listA - 第一个链表
listB - 第二个链表
skipA - 在 listA 中(从头节点开始)跳到交叉节点的节点数
skipB - 在 listB 中(从头节点开始)跳到交叉节点的节点数
评测系统将根据这些输入创建链式数据结构,并将两个头节点 headA 和 headB 传递给你的程序。如果程序能够正确返回相交节点,那么你的解决方案将被 视作正确答案 。


输入:intersectVal = 8, listA = [4,1,8,4,5], listB = [5,6,1,8,4,5], skipA = 2, skipB = 3
输出:Intersected at '8'
解释:相交节点的值为 8 (注意,如果两个链表相交则不能为 0)。
从各自的表头开始算起,链表 A 为 [4,1,8,4,5],链表 B 为 [5,6,1,8,4,5]。
在 A 中,相交节点前有 2 个节点;在 B 中,相交节点前有 3 个节点。

  1. public class Solution {
  2. public ListNode getIntersectionNode(ListNode headA, ListNode headB) {
  3. ListNode a = headA;
  4. ListNode b = headB;
  5. while(a != b){
  6. a = (a != null ? a.next : headB);
  7. b = (b != null ? b.next : headA);
  8. }
  9. return a;
  10. }
  11. }

 【1】:

 走到尽头见不到你,于是走过你来时的路,等到相遇时才发现,你也走过我来时的路【2】

8. leetcode142 环形链表II

        给定一个链表的头节点  head ,返回链表开始入环的第一个节点。 如果链表无环,则返回 null。如果链表中有某个节点,可以通过连续跟踪 next 指针再次到达,则链表中存在环。 为了表示给定链表中的环,评测系统内部使用整数 pos 来表示链表尾连接到链表中的位置(索引从 0 开始)。如果 pos 是 -1,则在该链表中没有环。注意:pos 不作为参数进行传递,仅仅是为了标识链表的实际情况。不允许修改 链表。


输入:head = [3,2,0,-4], pos = 1
输出:返回索引为 1 的链表节点
解释:链表中有一个环,其尾部连接到第二个节点。

  1. public class Solution {
  2. public ListNode detectCycle(ListNode head) {
  3. if(head == null || head.next == null) return null;
  4. ListNode fast = head;
  5. ListNode slow = head;
  6. while(true){
  7. if(fast == null || fast.next == null) return null;
  8. slow = slow.next;
  9. fast = fast.next.next;
  10. if(slow == fast) break;
  11. }
  12. fast = head;
  13. while(fast != slow){
  14. fast = fast.next;
  15. slow = slow.next;
  16. }
  17. return fast;
  18. }
  19. }

本题小结:(1)这个和环形链表I很相似,但是要判断出具体环形的入口

                  (2)在while(true)种设置关于fast遇到不是环形链表的情况提前退出

9. leetcode203 移除链表元素

        给你一个链表的头节点 head 和一个整数 val ,请你删除链表中所有满足 Node.val == val 的节点,并返回 新的头节点 。

输入:head = [1,2,6,3,4,5,6], val = 6
输出:[1,2,3,4,5]

  1. class Solution {
  2. public ListNode removeElements(ListNode head, int val) {
  3. if(head == null) return null;
  4. ListNode dummyhead = new ListNode(0);
  5. dummyhead.next = head;
  6. ListNode tail = dummyhead;
  7. ListNode pre = head;
  8. while(pre != null){
  9. if(pre.val == val){
  10. tail.next = pre.next;
  11. pre = tail.next;
  12. }
  13. else{
  14. pre = pre.next;
  15. tail = tail.next;
  16. }
  17. }
  18. return dummyhead.next;
  19. }
  20. }

本题小结:(1)对于首,采用dummyhead是不错的选择

                  (2)对于找到要删除的值,在tail连接好后,pre向前移就可以,因为此时的pre没有被比较过

10. leetcode876 链表的中间节点

        给定一个头结点为 head 的非空单链表,返回链表的中间结点。如果有两个中间结点,则返回第二个中间结点。

输入:[1,2,3,4,5]
输出:此列表中的结点 3 (序列化形式:[3,4,5])
返回的结点值为 3 。 (测评系统对该结点序列化表述是 [3,4,5])。
注意,我们返回了一个 ListNode 类型的对象 ans,这样:
ans.val = 3, ans.next.val = 4, ans.next.next.val = 5, 以及 ans.next.next.next = NULL.
 

  1. class Solution {
  2. public ListNode middleNode(ListNode head) {
  3. ListNode slow = head;
  4. ListNode fast = head;
  5. while(fast != null && fast.next != null){
  6. fast = fast.next.next;
  7. slow = slow.next;
  8. }
  9. return slow;
  10. }
  11. }

11. leetcode 面试题 02.01. 移除重复节点

编写代码,移除未排序链表中的重复节点。保留最开始出现的节点。

 输入:[1, 2, 3, 3, 2, 1]
 输出:[1, 2, 3]

  1. class Solution {
  2. public ListNode removeDuplicateNodes(ListNode head) {
  3. if(head == null || head.next == null) return head;
  4. ListNode tail = head;
  5. ListNode pre = head.next;
  6. HashSet<Integer> set = new HashSet<>();
  7. set.add(head.val);
  8. while(pre != null){
  9. if(set.contains(pre.val)){
  10. pre = pre.next;
  11. tail.next = pre;
  12. }
  13. else{
  14. set.add(pre.val);
  15. pre = pre.next;
  16. tail = tail.next;
  17. }
  18. }
  19. return head;
  20. }
  21. }

建立HashSet明显是好做得题目,没有缓冲区怎么办?

也可以使用双重暴力循环来做,花费时间的选项

  1. class Solution {
  2. public ListNode removeDuplicateNodes(ListNode head) {
  3. if(head == null || head.next == null) return head;
  4. ListNode cur = head;
  5. while(cur != null){
  6. ListNode temp = cur;
  7. while(temp.next != null){
  8. if(cur.val == temp.next.val){
  9. temp.next = temp.next.next;
  10. }
  11. else{
  12. temp = temp.next;
  13. }
  14. }
  15. cur = cur.next;
  16. }
  17. return head;
  18. }
  19. }

11. leetcode 剑指 Offer 22. 链表中倒数第k个节点

输入一个链表,输出该链表中倒数第k个节点。为了符合大多数人的习惯,本题从1开始计数,即链表的尾节点是倒数第1个节点。
例如,一个链表有 6 个节点,从头节点开始,它们的值依次是 1、2、3、4、5、6。这个链表的倒数第 3 个节点是值为 4 的节点。

        给定一个链表: 1->2->3->4->5, 和 k = 2.

        返回链表 4->5.

  1. class Solution {
  2. public ListNode getKthFromEnd(ListNode head, int k) {
  3. Deque<ListNode> list = new ArrayDeque<>();
  4. ListNode cur = head;
  5. while(cur != null){
  6. list.push(cur);
  7. cur = cur.next;
  8. }
  9. while(k > 1){
  10. list.pop();
  11. k--;
  12. }
  13. return list.pop();
  14. }
  15. }

 

12. leetcode 61 旋转链表

给你一个链表的头节点 head ,旋转链表,将链表每个节点向右移动 k 个位置。

输入:head = [1,2,3,4,5], k = 2
输出:[4,5,1,2,3]

  1. class Solution {
  2. public ListNode rotateRight(ListNode head, int k) {
  3. if(head == null || head.next == null) return head;
  4. int sum = 1;
  5. ListNode pre = head;
  6. while(pre.next != null){
  7. sum++;
  8. pre = pre.next;
  9. }
  10. System.out.println(sum);
  11. int diff = k % sum;
  12. System.out.println(diff);
  13. if(diff == 0) return head;
  14. ListNode cur = head;
  15. for(int i = 1; i < sum - diff; i++){
  16. cur = cur.next;
  17. }
  18. ListNode temp = cur.next;
  19. cur.next = null;
  20. pre.next = head;
  21. return temp;
  22. }
  23. }

本题小结:(1)可以通过取余节省时间(数据量小没用)

                  (2)剩下需要移动的位置就是sum - diff-1了,注意起始值

13. leetcode 19 删除链表的倒数第N个节点

给你一个链表,删除链表的倒数第 n 个结点,并且返回链表的头结点。

输入:head = [1,2,3,4,5], n = 2
输出:[1,2,3,5]

 双指针,有一个要先走

  1. class Solution {
  2. public ListNode removeNthFromEnd(ListNode head, int n) {
  3. if(head == null || n < 1){
  4. return head;
  5. }
  6. ListNode prehead = new ListNode(0);
  7. prehead.next = head;
  8. ListNode fast = prehead;
  9. ListNode slow = prehead;
  10. while(n >= 0){
  11. fast = fast.next;
  12. n--;
  13. }
  14. while(fast != null){
  15. fast = fast.next;
  16. slow = slow.next;
  17. }
  18. if(slow == prehead){
  19. return head.next;
  20. }
  21. slow.next = slow.next.next;
  22. return prehead.next;
  23. }
  24. }

栈,装满倒序遍历

  1. class Solution {
  2. public ListNode removeNthFromEnd(ListNode head, int n) {
  3. if(head == null) return head;
  4. ListNode dummyhead = new ListNode(0);
  5. dummyhead.next = head;
  6. ListNode cur = dummyhead;
  7. Deque<ListNode> list = new ArrayDeque<>();
  8. while(cur != null){
  9. list.push(cur);
  10. cur = cur.next;
  11. }
  12. while(n > 1){
  13. list.pop();
  14. n--;
  15. }
  16. ListNode pre = list.pop();
  17. ListNode tail = list.pop();
  18. tail.next = pre.next;
  19. return dummyhead.next;
  20. }
  21. }

 

参考自

【1】leetcode 房建斌学算法 图解相交链表

【2】leetcode  sylin 

声明:本文内容由网友自发贡献,不代表【wpsshop博客】立场,版权归原作者所有,本站不承担相应法律责任。如您发现有侵权的内容,请联系我们。转载请注明出处:https://www.wpsshop.cn/w/小蓝xlanll/article/detail/687133
推荐阅读
相关标签
  

闽ICP备14008679号